# $Revision: 1.42 $, $Date: 2007/01/28 15:41:31 $
#
# Conditional build:
%bcond_without	threads	# build thread-safe library (requires nspr)
%bcond_with	java	# with libjsj and lshell
#
%ifarch i386 i486 ppc ppc64
%undefine	with_java
%endif
#
%include        /usr/lib/rpm/macros.perl
Summary:	JavaScript Reference Implementation
Summary(pl):	Wzorcowa implementacja JavaScriptu
Name:		js
Version:	1.60
Release:	4
Epoch:		1
License:	GPL or Netscape Public License 1.1
Group:		Libraries
Source0:	http://ftp.mozilla.org/pub/mozilla.org/js/%{name}-%{version}.tar.gz
# Source0-md5:	bd8f021e43a8fbbec55ac2cd3d483243
Patch0:		%{name}-makefile.patch
URL:		http://www.mozilla.org/js/
%{?with_java:BuildRequires:	jdk}
%{?with_java:BuildRequires:	jpackage-utils}
%{?with_threads:BuildRequires:	nspr-devel}
BuildRequires:	perl-devel
BuildRequires:	readline-devel
BuildRequires:	rpm-perlprov
BuildRequires:	rpmbuild(macros) >= 1.294
Conflicts:	njs
%{?with_threads:Provides:	js(threads)}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		classdir	%{_datadir}/java

%description
JavaScript Reference Implementation (codename SpiderMonkey). The
package contains JavaScript runtime (compiler, interpreter,
decompiler, garbage collector, atom manager, standard classes) and
small "shell" program that can be used interactively and with .js
files to run scripts.

%description -l pl
Wzorcowa implementacja JavaScriptu (o nazwie kodowej SpiderMonkey).
Pakiet zawiera rodowisko uruchomieniowe (kompilator, interpreter,
dekompilator, odmiecacz, standardowe klasy) i niewielk powok,
ktra moe by uywana interaktywnie lub z plikami .js do uruchamiania
skryptw.

%package devel
Summary:	Header files for JavaScript reference library
Summary(pl):	Pliki nagwkowe do biblioteki JavaScript
Group:		Development/Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}
Conflicts:	njs-devel
%{?with_threads:Provides:	js-devel(threads)}

%description devel
Header files for JavaScript reference library.

%description devel -l pl
Pliki nagwkowe do biblioteki JavaScript.

%package static
Summary:	Static JavaScript reference library
Summary(pl):	Statyczna biblioteka JavaScript
Group:		Development/Libraries
Requires:	%{name}-devel = %{epoch}:%{version}-%{release}
Conflicts:	njs-static
%{?with_threads:Provides:	js-static(threads)}

%description static
Static version of JavaScript reference library.

%description static -l pl
Statyczna wersja biblioteki JavaScript.

%package java
Summary:	JavaScript LiveConnect Version 3 implementation
Summary(pl):	Implementacja JavaScript LiveConnect w wersji 3
Group:		Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}
Conflicts:	mozilla
Conflicts:	mozilla-embedded

%description java
LiveConnect is a library that permits JavaScript and Java virtual
machines to interoperate. Specifically, it enables JavaScript to
access Java fields, invoke Java methods and enables Java to access
JavaScript object properties and evaluate arbitrary JavaScript.
LiveConnect was originally an integrated feature of both the Netscape
Navigator browser and Netscape's server-side JavaScript. Now, it is a
standalone library that can be embedded within other projects, such as
the Mozilla browser.

%description java -l pl
LiveConnect to biblioteka pozwalajca na wspprac maszyn wirtualnych
JavaScriptu i Javy. W szczeglnoci pozwala z poziomu JavaScriptu na
dostp do pl Javy, wywoywanie metod Javy oraz z poziomu Javy na
dostp do skadowych obiektw JavaScriptu i wykonywanie dowolnego kodu
w JavaScripcie. LiveConnect oryginalnie by zintegrowan czci
przegldarki Netscape Navigator oraz Netscape JavaScript dziaajcego
po stronie serwera. Teraz jest to samodzielna biblioteka, ktr mona
osadza w innych projektach, takich jak przegldarka Mozilla.

%package java-devel
Summary:	JavaScript LiveConnect 3 implementation header files
Summary(pl):	Pliki nagwkowe implementacji JavaScript LiveConnect 3
Group:		Development/Libraries
Requires:	%{name}-devel = %{epoch}:%{version}-%{release}
Requires:	%{name}-java = %{epoch}:%{version}-%{release}

%description java-devel
JavaScript LiveConnect 3 implementation header files.

%description java-devel -l pl
Pliki nagwkowe implementacji JavaScript LiveConnect 3.

%package java-static
Summary:	JavaScript Live Connect 3 implementation static library
Summary(pl):	Biblioteka statyczna implementacji JavaScript LiveConnect 3
Group:		Development/Libraries
Requires:	%{name}-java-devel = %{epoch}:%{version}-%{release}

%description java-static
JavaScript Live Connect 3 implementation static library.

%description java-static -l pl
Biblioteka statyczna implementacji JavaScript LiveConnect 3.

%package -n perl-JS
Summary:	JS Perl module - interface to JavaScript
Summary(pl):	Modu Perla JS - interfejs do JavaScriptu
Group:		Development/Languages/Perl
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description -n perl-JS
JS Perl module allows calling JavaScript from Perl.

%description -n perl-JS -l pl
Modu Perla JS pozwalajcy na wywoywanie JavaScriptu z Perla.

%prep
%setup -q -n %{name}
%patch0 -p1

echo 'SONAME=libjs.so.0' >> src/Makefile.ref
echo 'SONAME=libjsj.so.0' >> src/liveconnect/Makefile.ref

%build
%{__make} -j1 -C src -f Makefile.ref \
	%{!?debug:BUILD_OPT=1} \
	OPTIMIZER="%{rpmcflags} -DHAVE_VA_COPY -DVA_COPY=va_copy" \
	JS_READLINE=1 \
	CC="%{__cc}" \
	LDFLAGS="%{rpmldflags}" \
	MKSHLIB="%{__cc} -shared -Wl,-soname=\$(SONAME)" \
	%{?with_threads:JS_THREADSAFE=1} \
	%{?with_java:JS_LIVECONNECT=1 JDK=%{java_home}}

# js segfaults when jsperl is compiled in
#	JS_PERLCONNECT=1

cd src/perlconnect
%{!?debug:BUILD_OPT=1} \
%{__perl} Makefile.PL \
	INSTALLDIRS=vendor

%{__make} \
	OPTIMIZE="%{rpmcflags}"

# no UNIX makefiles
# %{__make} -C jsd

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_bindir},%{_libdir},%{_includedir}/js,%{classdir}}

cd src
install Linux*/{js,jscpucfg} $RPM_BUILD_ROOT%{_bindir}
install Linux*/libjs.a $RPM_BUILD_ROOT%{_libdir}
install Linux*/libjs.so $RPM_BUILD_ROOT%{_libdir}/libjs.so.0.1.0
ln -sf libjs.so.0 $RPM_BUILD_ROOT%{_libdir}/libjs.so
install Linux*/jsautocfg.h $RPM_BUILD_ROOT%{_includedir}/js
install js.msg jsapi.h jsarray.h jsarena.h jsatom.h jsbit.h jsbool.h \
	jsclist.h jscntxt.h jscompat.h jsconfig.h jsdate.h jsdbgapi.h \
	jsdhash.h jsemit.h jsfun.h jsgc.h jshash.h jsinterp.h jslock.h \
	jslong.h jsmath.h jsnum.h jsobj.h jsopcode.tbl jsopcode.h jsosdep.h \
	jsotypes.h jsparse.h jsprf.h jsprvtd.h jspubtd.h jsregexp.h jsscan.h \
	jsscope.h jsscript.h jsstr.h jstypes.h jsutil.h jsxdrapi.h jsstddef.h \
	$RPM_BUILD_ROOT%{_includedir}/js

%if %{with java}
install liveconnect/Linux*/libjsj.a $RPM_BUILD_ROOT%{_libdir}
install liveconnect/Linux*/libjsj.so $RPM_BUILD_ROOT%{_libdir}/libjsj.so.0.1.0
ln -sf libjsj.so.0 $RPM_BUILD_ROOT%{_libdir}/libjsj.so
install liveconnect/Linux*/lcshell $RPM_BUILD_ROOT%{_bindir}
install liveconnect/classes/Linux*/*.jar $RPM_BUILD_ROOT%{classdir}
install liveconnect/{jsjava.h,nsI*.h,_jni/*.h} $RPM_BUILD_ROOT%{_includedir}/js
%endif

%{__make} -C perlconnect pure_install \
	DESTDIR=$RPM_BUILD_ROOT

cp -f perlconnect/README.html README-perlconnect.html

/sbin/ldconfig -n -N $RPM_BUILD_ROOT%{_libdir}

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%post	java -p /sbin/ldconfig
%postun	java -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc src/README*.html
%attr(755,root,root) %{_bindir}/js*
%attr(755,root,root) %{_libdir}/libjs.so.*

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libjs.so
%dir %{_includedir}/js
%{_includedir}/js/js.msg
%{_includedir}/js/jsopcode.tbl
%{_includedir}/js/js[!j]*.h

%files static
%defattr(644,root,root,755)
%{_libdir}/libjs.a

%if %{with java}
%files java
%defattr(644,root,root,755)
%doc src/liveconnect/README.html
%attr(755,root,root) %{_bindir}/lcshell
%attr(755,root,root) %{_libdir}/libjsj.so.*
%{classdir}/*.jar

%files java-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libjsj.so
%{_includedir}/js/jsjava.h
%{_includedir}/js/n*.h

%files java-static
%defattr(644,root,root,755)
%{_libdir}/libjsj.a
%endif

%files -n perl-JS
%defattr(644,root,root,755)
%{perl_vendorarch}/JS.pm
%{perl_vendorarch}/jsperlbuild.pl
%dir %{perl_vendorarch}/auto/JS
%{perl_vendorarch}/auto/JS/JS.bs
%attr(755,root,root) %{perl_vendorarch}/auto/JS/JS.so
# unusable now (helper module for PerlConnect in libjs, which is not built)
#%%{perl_vendorarch}/PerlConnect.pm

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: js.spec,v $
Revision 1.42  2007/01/28 15:41:31  arekm
- generate missing symlinks

Revision 1.41  2007/01/28 15:37:16  arekm
- rel 4

Revision 1.40  2007/01/28 15:31:37  arekm
- rel 3

Revision 1.39  2007/01/28 15:27:32  arekm
- enable threads

Revision 1.38  2007/01/15 07:20:53  qboosh
- macros for java_home

Revision 1.37  2007/01/15 07:20:18  qboosh
- updated to 1.60, use jpackage-utils

Revision 1.36  2006/09/27 13:45:48  shadzik
- P: js(threads),js-devel(threads),js-static(threads)
- rel 3

Revision 1.35  2006/09/06 17:18:44  sparky
- -j1, build broken on smp

Revision 1.34  2006/08/03 23:54:04  sparky
- pass rpmldflags

Revision 1.33  2005/10/30 15:14:56  qboosh
- updated to final 1.5, release 2

Revision 1.32  2005/09/17 10:33:56  arekm
- rebuild with readline 5.0

Revision 1.31  2005/05/11 18:42:03  adamg
- release 2 for Th

Revision 1.30  2005/05/11 18:39:37  adamg
- cp instead of move in %install
- release 1.rc6a (to avoid epoch bump)

Revision 1.29  2005/03/23 17:18:07  glen
- dropped SourceX-size

Revision 1.28  2004/12/14 16:59:56  baggins
- DON'T hardcode java paths!

Revision 1.27  2004/10/26 19:38:00  qboosh
- spacing

Revision 1.26  2004/10/25 11:47:23  paladine
- "Perl" unifications

Revision 1.25  2004/10/23 07:50:09  witekfl
- upgrade to 1.5rc6a
- introduced Epoch

Revision 1.24  2004/03/24 19:40:03  qboosh
- fixed -java build with new soname scheme

Revision 1.23  2004/03/24 18:26:22  qboosh
- use gcc to link shared lib (fixes build on sparc)

Revision 1.22  2004/03/24 17:11:05  undefine
- use libs.so.x.x.x format
- release 2

Revision 1.21  2004/03/24 16:05:32  qboosh
- define HAVE_VA_COPY to use va_copy on all archs

Revision 1.20  2004/03/24 16:02:24  qboosh
- added PIC fix to makefile patch
- define VA_COPY=va_copy (used on amd64)

Revision 1.19  2004/03/24 14:33:06  undefine
- update to 1.6, use strict version-release R:

Revision 1.18  2004/01/27 00:08:09  qboosh
- what kernel-headers?! removed from BR.

Revision 1.17  2004/01/26 23:20:41  qboosh
- new-style bconds

Revision 1.16  2003/08/11 22:46:32  ankry
- cosmetics

Revision 1.15  2003/07/28 00:58:57  martii
- BR added; does not build without kernel-headers

Revision 1.14  2003/07/06 10:13:33  ankry
- fixed md5

Revision 1.13  2003/07/04 22:44:18  qboosh
- updated to rc5a, added more fixes to makefile patch

Revision 1.12  2003/05/28 12:59:15  malekith
- massive attack: source-md5

Revision 1.11  2003/05/25 05:49:11  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.10  2003/03/25 23:37:20  qboosh
- Ra is on RA-branch, not here! s/site/vendor/ back

Revision 1.9  2003/03/23 14:10:02  grzegorz
- sed s/vendor/site/, now builds on Ra

Revision 1.8  2003/03/23 13:32:24  grzegorz
- added BR: perl-devel

Revision 1.7  2003/03/20 17:41:56  qboosh
- fixed build

Revision 1.6  2003/03/19 22:45:17  pbern
- update to rc5

Revision 1.5  2003/03/02 20:53:39  radek
- updated for perl-5.8; release *.2: untested

Revision 1.4  2003/02/28 10:07:58  trojan
- massive attack: perl -pi -e "s/^#+\%\{/#\%\%\{/"

Revision 1.3  2003/01/25 14:37:16  qboosh
- changed Obsoletes: njs to Conflicts (these libs aren't compatible at all!)
- separated java subpackages (conflict with mozilla), added missing .jar
- release 0.rc4a.1

Revision 1.2  2003/01/11 13:06:01  juandon
- added Obsoletes: njs

Revision 1.1  2002/05/18 21:33:00  qboosh
- new
